/***(nxkeycodes.h)*************************************************************
*H* Define keyboard constants for NeXT's mystifying keyboard encoding.        *
******************************************************************************/

#ifndef _NXKEYCODES_H_
#define _NXKEYCODES_H_

#define NX_KEYCODE_ESCAPE 	    0x49
#define NX_KEYCODE_1	 	    0x4A
#define NX_KEYCODE_2 	    	    0x4B
#define NX_KEYCODE_3 	    	    0x4C
#define NX_KEYCODE_4 	    	    0x4D
#define NX_KEYCODE_5 	    	    0x50
#define NX_KEYCODE_6 	    	    0x4F
#define NX_KEYCODE_7 	    	    0x4E
#define NX_KEYCODE_8 	    	    0x1E
#define NX_KEYCODE_9 	    	    0x1F
#define NX_KEYCODE_0 	    	    0x20
#define NX_KEYCODE_HYPHEN    	    0x1D
#define NX_KEYCODE_EQUAL    	    0x1C
#define NX_KEYCODE_DELETE    	    0x1B

#define NX_KEYCODE_TAB 	    	    0x41
#define NX_KEYCODE_Q 	    	    0x42
#define NX_KEYCODE_W 	    	    0x43
#define NX_KEYCODE_E 	    	    0x44
#define NX_KEYCODE_R 	    	    0x45
#define NX_KEYCODE_T 	    	    0x48
#define NX_KEYCODE_Y 	    	    0x47
#define NX_KEYCODE_U 	    	    0x46
#define NX_KEYCODE_I	 	    0x06
#define NX_KEYCODE_O 	            0x07
#define NX_KEYCODE_P 	    	    0x08
#define NX_KEYCODE_LBRACKET 	    0x05
#define NX_KEYCODE_RBRACKET 	    0x04
#define NX_KEYCODE_BACKSLASH 	    0x03

#define NX_KEYCODE_CONTROL 	    0x51
#define NX_KEYCODE_A 	    	    0x39
#define NX_KEYCODE_S 	    	    0x3A
#define NX_KEYCODE_D 	    	    0x3B
#define NX_KEYCODE_F 	    	    0x3C
#define NX_KEYCODE_G 	    	    0x3D
#define NX_KEYCODE_H 	    	    0x40
#define NX_KEYCODE_J 	    	    0x3F
#define NX_KEYCODE_K 	    	    0x3E
#define NX_KEYCODE_L 	    	    0x2D
#define NX_KEYCODE_SEMICOLON 	    0x2C
#define NX_KEYCODE_APOSTROPHE 	    0x2B
#define NX_KEYCODE_RETURN 	    0x2A

#define NX_KEYCODE_LSHIFT 	    0x52
#define NX_KEYCODE_Z 	    	    0x31
#define NX_KEYCODE_X 	    	    0x32
#define NX_KEYCODE_C 	    	    0x33
#define NX_KEYCODE_V 	    	    0x34
#define NX_KEYCODE_B 	    	    0x35
#define NX_KEYCODE_N 	    	    0x37
#define NX_KEYCODE_M 	    	    0x36
#define NX_KEYCODE_COMMA 	    0x2E
#define NX_KEYCODE_PERIOD 	    0x2F
#define NX_KEYCODE_SLASH 	    0x30
#define NX_KEYCODE_RSHIFT 	    0x57

#define NX_KEYCODE_LALTERNATE 	    0x53
#define NX_KEYCODE_LCOMMAND 	    0x54
#define NX_KEYCODE_SPACE 	    0x38
#define NX_KEYCODE_RCOMMAND 	    0x55
#define NX_KEYCODE_RALTERNATE 	    0x56

#define NX_KEYCODE_UP	 	    0x16
#define NX_KEYCODE_DOWN 	    0x0F
#define NX_KEYCODE_RIGHT 	    0x10
#define NX_KEYCODE_LEFT 	    0x09

#define NX_KEYCODE_KP_TILDE 	    0x26
#define NX_KEYCODE_KP_EQUAL 	    0x27
#define NX_KEYCODE_KP_DIVIDE 	    0x28
#define NX_KEYCODE_KP_ASTERISK 	    0x25
#define NX_KEYCODE_KP_MINUS 	    0x24
#define NX_KEYCODE_KP_PLUS 	    0x15
#define NX_KEYCODE_KP_ENTER 	    0x0D
#define NX_KEYCODE_KP_PERIOD 	    0x0C
#define NX_KEYCODE_KP_0 	    0x0B
#define NX_KEYCODE_KP_1 	    0x11
#define NX_KEYCODE_KP_2 	    0x17
#define NX_KEYCODE_KP_3 	    0x14
#define NX_KEYCODE_KP_4 	    0x12
#define NX_KEYCODE_KP_5 	    0x18
#define NX_KEYCODE_KP_6 	    0x13
#define NX_KEYCODE_KP_7 	    0x21
#define NX_KEYCODE_KP_8 	    0x22
#define NX_KEYCODE_KP_9 	    0x23

#define NX_CHRCODE_ALT_a	    202		/* charSet: 0 */
#define NX_CHRCODE_ALT_A	    199		/* charSet: 0 */
#define NX_CHRCODE_ALT_b	    229		/* charSet: 1 */
#define NX_CHRCODE_ALT_B	    242		/* charSet: 1 */
#define NX_CHRCODE_ALT_c	    227		/* charSet: 1 */
#define NX_CHRCODE_ALT_C	    211		/* charSet: 1 */
#define NX_CHRCODE_ALT_d	     68		/* charSet: 1 */
#define NX_CHRCODE_ALT_D	    182		/* charSet: 1 */
#define NX_CHRCODE_ALT_e	    194		/* charSet: 0 */
#define NX_CHRCODE_ALT_E	    197		/* charSet: 0 */
#define NX_CHRCODE_ALT_f	    166		/* charSet: 0 */
#define NX_CHRCODE_ALT_F	    172		/* charSet: 0 */
#define NX_CHRCODE_ALT_g	    241		/* charSet: 0 */
#define NX_CHRCODE_ALT_G	    225		/* charSet: 0 */
#define NX_CHRCODE_ALT_h	    227		/* charSet: 0 */
#define NX_CHRCODE_ALT_H	    235		/* charSet: 0 */
#define NX_CHRCODE_ALT_i	    193		/* charSet: 0 */
#define NX_CHRCODE_ALT_I	    245		/* charSet: 0 */
#define NX_CHRCODE_ALT_j	    198		/* charSet: 0 */
#define NX_CHRCODE_ALT_J	    174		/* charSet: 0 */
#define NX_CHRCODE_ALT_k	    206		/* charSet: 0 */
#define NX_CHRCODE_ALT_K	    175		/* charSet: 0 */
#define NX_CHRCODE_ALT_l	    248		/* charSet: 0 */
#define NX_CHRCODE_ALT_L	    232		/* charSet: 0 */
#define NX_CHRCODE_ALT_m	    109		/* charSet: 1 */
#define NX_CHRCODE_ALT_M	    216		/* charSet: 1 */
#define NX_CHRCODE_ALT_n	    196		/* charSet: 0 */
#define NX_CHRCODE_ALT_N	    175		/* charSet: 1 */
#define NX_CHRCODE_ALT_o	    249		/* charSet: 0 */
#define NX_CHRCODE_ALT_O	    233		/* charSet: 0 */
#define NX_CHRCODE_ALT_p	    112		/* charSet: 1 */
#define NX_CHRCODE_ALT_P	     80		/* charSet: 1 */
#define NX_CHRCODE_ALT_q	    250		/* charSet: 0 */
#define NX_CHRCODE_ALT_Q	    234		/* charSet: 0 */
#define NX_CHRCODE_ALT_r	    226		/* charSet: 1 */
#define NX_CHRCODE_ALT_R	    210		/* charSet: 1 */
#define NX_CHRCODE_ALT_s	    251		/* charSet: 0 */
#define NX_CHRCODE_ALT_S	    167		/* charSet: 0 */
#define NX_CHRCODE_ALT_t	    228		/* charSet: 1 */
#define NX_CHRCODE_ALT_T	    212		/* charSet: 1 */
#define NX_CHRCODE_ALT_u	    200		/* charSet: 0 */
#define NX_CHRCODE_ALT_U	    205		/* charSet: 0 */
#define NX_CHRCODE_ALT_v	    214		/* charSet: 1 */
#define NX_CHRCODE_ALT_V	    224		/* charSet: 1 */
#define NX_CHRCODE_ALT_w	    200		/* charSet: 1 */
#define NX_CHRCODE_ALT_W	    199		/* charSet: 1 */
#define NX_CHRCODE_ALT_x	    180		/* charSet: 1 */
#define NX_CHRCODE_ALT_X	    206		/* charSet: 1 */
#define NX_CHRCODE_ALT_y	    165		/* charSet: 0 */
#define NX_CHRCODE_ALT_Y	    219		/* charSet: 1 */
#define NX_CHRCODE_ALT_z	    207		/* charSet: 0 */
#define NX_CHRCODE_ALT_Z	     87		/* charSet: 1 */
#define NX_CHRCODE_ALT_0	    173		/* charSet: 0 */
#define NX_CHRCODE_ALT_1	    173		/* charSet: 1 */
#define NX_CHRCODE_ALT_2	    178		/* charSet: 0 */
#define NX_CHRCODE_ALT_3	    163		/* charSet: 0 */
#define NX_CHRCODE_ALT_4	    162		/* charSet: 0 */
#define NX_CHRCODE_ALT_5	    165		/* charSet: 1 */
#define NX_CHRCODE_ALT_6	    182		/* charSet: 0 */
#define NX_CHRCODE_ALT_7	    183		/* charSet: 0 */
#define NX_CHRCODE_ALT_8	    176		/* charSet: 1 */
#define NX_CHRCODE_ALT_9	    172		/* charSet: 0 */

#define NX_CHRCODE_ALT_ENTER	      3		/* charSet: 0 */
#define NX_CHRCODE_UP		    173		/* charSet: 1 */
#define NX_CHRCODE_DOWN		    175		/* charSet: 1 */
#define NX_CHRCODE_LEFT		    172		/* charSet: 1 */
#define NX_CHRCODE_RIGHT	    174		/* charSet: 1 */

#define NX_CHRCODE_ALT_EXCLAMATION  161		/* charSet: 0 */
#define NX_CHRCODE_ALT_AT	    179		/* charSet: 0 */
#define NX_CHRCODE_ALT_NUMBER	    186		/* charSet: 1 */
#define NX_CHRCODE_ALT_DOLLAR	    168		/* charSet: 0 */
#define NX_CHRCODE_ALT_PERCENT	    189		/* charSet: 0 */
#define NX_CHRCODE_ALT_CIRCUMFLEX   195		/* charSet: 0 */
#define NX_CHRCODE_ALT_AMPERSAND    171		/* charSet: 1 */
#define NX_CHRCODE_ALT_ASTERISK	    180		/* charSet: 0 */
#define NX_CHRCODE_ALT_LPAREN	    171		/* charSet: 0 */
#define NX_CHRCODE_ALT_RPAREN	    187		/* charSet: 0 */
#define NX_CHRCODE_ALT_MINUS	    177		/* charSet: 0 */
#define NX_CHRCODE_ALT_UNDERBAR	    208		/* charSet: 0 */
#define NX_CHRCODE_ALT_EQUALS	    185		/* charSet: 1 */
#define NX_CHRCODE_ALT_PLUS	    177		/* charSet: 1 */
#define NX_CHRCODE_ALT_LBRACE	    170		/* charSet: 0 */
#define NX_CHRCODE_ALT_RBRACE	    186		/* charSet: 0 */
#define NX_CHRCODE_ALT_BACKSLASH    227		/* charSet: 0 */
#define NX_CHRCODE_ALT_PIPE	    235		/* charSet: 0 */
#define NX_CHRCODE_ALT_SEMICOLON    178		/* charSet: 1 */
#define NX_CHRCODE_ALT_COLON	    162		/* charSet: 1 */
#define NX_CHRCODE_ALT_SINGLEQUOTE  169		/* charSet: 0 */
#define NX_CHRCODE_ALT_DOUBLEQUOTE  174		/* charSet: 1 */
#define NX_CHRCODE_ALT_COMMA	    203		/* charSet: 0 */
#define NX_CHRCODE_ALT_LANGLE	    163		/* charSet: 1 */
#define NX_CHRCODE_ALT_PERIOD	    188		/* charSet: 0 */
#define NX_CHRCODE_ALT_RANGLE	    179		/* charSet: 1 */
#define NX_CHRCODE_ALT_SLASH	    184		/* charSet: 1 */
#define NX_CHRCODE_ALT_QUESTIONMARK 191		/* charSet: 0 */
#define NX_CHRCODE_ALT_TILDE	    187		/* charSet: 1 */

#endif /* _NXKEYCODES_H_ */